Unit SF38R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF12_p, SF36R_p;

function SF38R(P :Real; A :Real; B :Real; var IERR :Integer): Real;

implementation

function SF38R(P :Real; A :Real; B :Real; var IERR :Integer): Real;
var
IC,IERR1 :Integer;
XL,XRMXL,X,XR,FXL,FXR,P1,FCS :Real;
const
ZERO :Real = 0.0;
ITMAX :Integer = 37;
SYS089 :Real = 1.0E-6;
SYS059 :Real = 1.7E38;
label
_1,_2,_3,_4,_5,_6,_7;
begin
{ Result -    SF38R  FORTRANe }
IERR := 0;
IC := 0;
if ( (A > 0.0) ) and ( (B > 0.0) ) 
 then goto _1;
IERR := 65;
goto _6;
_1:
XL := 0.0;
XR := 1.0;
FXL := -P;
FXR := 1.0-P;
if ( FXL*FXR > ZERO ) 
 then goto _5;
_2:
X := (XL+XR)*0.5;
Result := X;
P1 := SF36R(X,A,B,IERR1);
FCS := P1-P;
if ( FCS*FXL > ZERO ) 
 then goto _3;
XR := X;
FXR := FCS;
goto _4;
_3:
XL := X;
FXL := FCS;
_4:
XRMXL := XR-XL;
if ( Abs(FCS) <= SYS089 ) and ( XRMXL <= SYS089*Abs(X) ) 
 then goto _7;
IC := IC+1;
if ( IC <= ITMAX ) 
 then goto _2;
goto _7;
_5:
IERR := 67;
_6:
UTSF12(IERR,38);
Result := SYS059;
_7:
exit;
end;

end.
