Unit SF44R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTSF12_p, SF38R_p;

function SF44R(P :Real; AN1 :Real; AN2 :Real;
                var IERR :Integer): Real;

implementation

function SF44R(P :Real; AN1 :Real; AN2 :Real;
                var IERR :Integer): Real;
var
IERR1,IFOVFL :Integer;
A,B,X :Real;
const
SYS059 :Real = 3.4E38;
label
_1,_2,_3,_5,_6;
begin
{ Result -    SF44R  FORTRANe }
if ( P <= 0 ) or ( P >= 1.0 ) 
 then goto _2;
IERR := 0;
if ( (AN1 > 0) ) and ( (AN2 > 0) ) 
 then goto _1;
IERR := 66;
goto _5;
_1:
A := 0.5*AN1;
B := 0.5*AN2;
X := SF38R(P,A,B,IERR1);
Result := X;
if ( IERR1 <> 0 ) 
 then goto _3;
X := AN2*X/(AN1*(1.0-X));
Result := X;
goto _6;
_2:
IERR := 65;
goto _5;
_3:
IERR := 67;
goto _5;
_5:
UTSF12(IERR,44);
Result := SYS059;
_6:
exit;
end;

end.
